-- Useful draw functions

function drawshadowtext(text, x, y, w, align, font, r, g, b, a, click, outline, solid, f) 
  local mx, my = 800*love.mouse.getX()/love.graphics.getWidth() , 600*love.mouse.getY()/love.graphics.getHeight()
  local h = font:getHeight()
  local maxwidth, wrappedtext = font:getWrap(text, w)
  local l = 1
  click, outline, solid = click or "No", outline or "No", solid or "No"
  r, g, b, a, f = r or 255, g or 255, b or 255, a or 255, f or 255
  if next(wrappedtext)~=nil then l = #wrappedtext end
  -- Draw the rectangle first
  if solid == "Yes" then
    love.graphics.setColor(0, 0, 0, a)
    love.graphics.rectangle("fill", x-5+math.ceil(h/32), y-7+math.ceil(h/32), w+10, (h*l)+10)
    if (mx>x and mx<x+w and my>y and my<y+(h*l)) or click ~= "Yes" then love.graphics.setColor(r, g, b, a*0.33)
    else love.graphics.setColor(r, g, b, a*0.25) end
    love.graphics.rectangle("fill", x-5, y-7, w+10, (h*l)+10)
  end
  if outline == "Yes" then
    love.graphics.setColor(0, 0, 0, a)
    love.graphics.rectangle("line", x-5+math.ceil(h/32), y-7+math.ceil(h/32), w+10, (h*l)+10)
    if (mx>x and mx<x+w and my>y and my<y+(h*l)) or click ~= "Yes" then love.graphics.setColor(r, g, b, a)
    else love.graphics.setColor(r, g, b, a*0.7) end
    love.graphics.rectangle("line", x-5, y-7, w+10, (h*l)+10)
  end
  -- Print the shadow text
  love.graphics.setFont(font)
  love.graphics.setColor(0, 0, 0, a)
  love.graphics.printf(text, x+math.ceil(h/32), y+math.ceil(h/32), w, align)
  if click == "Yes" then
    love.graphics.setColor(r*0.7, g*0.7, b*0.7, a)
    love.graphics.printf(text, x, y, w, align)
    if mx>x and mx<x+w and my>y and my<y+(h*l) then
      love.graphics.setColor(r, g, b, f)
      love.graphics.printf(text, x, y, w, align)
    end
  else
    love.graphics.setColor(r, g, b, a)
    love.graphics.printf(text, x, y, w, align)
  end
end